10     DIM Adapter$[9],Meas_para$[9],Pow_mode$[9],Swp_type$[9]
20     DIM Fmt_a$[9],Fmt_b$[9],Buff$[9],Inp_char$[9],Img$[50]
30     REAL Start,Stop,Level,Data_a(1:2),Data_b(1:2)
40     REAL Err_limit,Range_l,Range_u
50     INTEGER Scode,Nop,Iteration,Result
60     CLEAR SCREEN
70     !
80     IF SYSTEM$("SYSTEM ID")="HP4294A" THEN 
90       ASSIGN @Hp4294a TO 800
100      Scode=8
110    ELSE
120      ASSIGN @Hp4294a TO 717
130      Scode=7
140    END IF
150    !
160    Adapter$="OFF"
170    Meas_para$="IMPH"
180    Swp_type$="LOG"
190    Start=1.0E+3
200    Stop=1.0E+7
210    Nop=21
220    Fmt_a$="LOGY"
230    Fmt_b$="LINY"
240    Pow_mode$="CURR"
250    Level=.001
260    Err_limit=1.0      ! Osc Level Error Limit: 1[%]
270    Iteration=10
280    !
290    OUTPUT @Hp4294a;"E4TP "&Adapter$
300    OUTPUT @Hp4294a;"PRES"
310    OUTPUT @Hp4294a;"MEAS "&Meas_para$
320    OUTPUT @Hp4294a;"SWPT "&Swp_type$
330    OUTPUT @Hp4294a;"STAR ";Start
340    OUTPUT @Hp4294a;"STOP ";Stop
350    OUTPUT @Hp4294a;"POIN ";Nop
360    !
370    ! Fixture Compensation (Open/Short)
380    !
390    OUTPUT @Hp4294a;"ESNB 256"
400    OUTPUT @Hp4294a;"*SRE 4"
410    Result=FNFixt_comp(@Hp4294a,Scode,"Open")
420    IF Result<>0 THEN Prog_end
430    Result=FNFixt_comp(@Hp4294a,Scode,"Short")
440    IF Result<>0 THEN Prog_end
450    !
460    OUTPUT @Hp4294a;"MANS ON"
470    OUTPUT @Hp4294a;"POWMOD ";Pow_mode$
480    OUTPUT @Hp4294a;"OMON ON"
490    OUTPUT @Hp4294a;"*OPC?"
500    ENTER @Hp4294a;Buff$
510    !
520    IF Pow_mode$="VOLT" THEN 
530      Command$="OUTPVACP? "
540      Range_l=.005
550      Range_u=1.0
560    ELSE
570      Command$="OUTPIACP? "
580      Range_l=.0002
590      Range_u=.02
600    END IF
610    !
620 Meas_start: !
630    !
640    PRINT "Set DUT, then Push [Enter] key"
650    INPUT "",Inp_char$
660    !
670    PRINT ""
680    PRINT "  #############  Measurement Result  #############"
690    PRINT "  Frequency   Monitor: "&Pow_mode$&"    Trace A     Trace B"
700    Img$="MD.5DE,2X,MD.4DE,4X,MD.4DE,X,MD.4DE"
710    FOR I=1 TO Nop
720      OUTPUT @Hp4294a;"MANP ";I
730      Set_lvl=Level
740      Count=0
750      Err=100.0
760      WHILE Count<Iteration AND ABS(Err)>Err_limit
770        OUTPUT @Hp4294a;"POWE ";Set_lvl
780        OUTPUT @Hp4294a;"SING"
790        OUTPUT @Hp4294a;"*OPC?"
800        ENTER @Hp4294a;Buff$
810        OUTPUT @Hp4294a;Command$;I
820        ENTER @Hp4294a;Mon_lvl
830        Err=(Level-Mon_lvl)/Level*100
840        Set_lvl=Level*(Set_lvl/Mon_lvl)
850        IF Set_lvl<Range_l THEN Set_lvl=Range_l
860        IF Set_lvl>Range_u THEN Set_lvl=Range_u
870        Count=Count+1
880      END WHILE
890      OUTPUT @Hp4294a;"TRAC A"
900      OUTPUT @Hp4294a;"OUTPDTRCP? ";I
910      ENTER @Hp4294a;Data_a(1),Data_a(2)
920      OUTPUT @Hp4294a;"TRAC B"
930      OUTPUT @Hp4294a;"OUTPDTRCP? ";I
940      ENTER @Hp4294a;Data_b(1),Data_b(2)
950      OUTPUT @Hp4294a;"OUTPSWPRMP? ";I
960      ENTER @Hp4294a;Swp_para
970      PRINT USING Img$;Swp_para,Mon_lvl,Data_a(1),Data_b(1)
980    NEXT I
990    OUTPUT @Hp4294a;"TRAC A"
1000   OUTPUT @Hp4294a;"FMT "&Fmt_a$
1010   OUTPUT @Hp4294a;"AUTO"
1020   OUTPUT @Hp4294a;"TRAC B"
1030   OUTPUT @Hp4294a;"FMT "&Fmt_b$
1040   OUTPUT @Hp4294a;"AUTO"
1050   !
1060   INPUT "Once more? [Y]es/[N]o",Inp_char$
1070   IF UPC$(Inp_char$)="Y" OR UPC$(Inp_char$)="YES" THEN Meas_start
1080 Prog_end:!
1090   END
1100   !
1110   ! Fixture Compensation Data Measurement Function
1120   !
1130 DEF FNFixt_comp(@Hp4294a,INTEGER Scode,Standard$)
1140   DIM Inp_char$[9],Err_mes$[50]
1150   INTEGER Err_no
1160   OUTPUT @Hp4294a;"*CLS"
1170   PRINT "Set "&Standard$&"-Connection"
1180   INPUT "OK? [Y/N]",Inp_char$
1190   IF UPC$(Inp_char$)="Y" THEN 
1200     ON INTR Scode GOTO Meas_end
1210     ENABLE INTR Scode;2
1220     SELECT Standard$
1230       CASE "Open"
1240         OUTPUT @Hp4294a;"COMA"
1250       CASE "Short"
1260         OUTPUT @Hp4294a;"COMB"
1270       CASE "Load"
1280         OUTPUT @Hp4294a;"COMC"
1290     END SELECT
1300     PRINT "Now measuring..."
1310 Meas_wait: GOTO Meas_wait
1320 Meas_end: !
1330     PRINT Standard$&" Data Measurement Complete"
1340     RETURN 0
1350   ELSE
1360     PRINT "Program Interruption"
1370     RETURN -1
1380   END IF
1390 FNEND
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4294A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      6/1/1999
5050   !* PROGRAM NAME: alc.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*    Copyright (c) 1999 Agilent Technologies,
5090   !*             All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
